/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "project.h"
#include "led.h"
#include "BLEProcess.h"
#include "main.h"
#include "stdio.h"
uint8 ON,COLOUR;
CYBLE_GATTS_WRITE_REQ_PARAM_T *wrReqParam;
CYBLE_CONN_HANDLE_T connectionHandle;

void HandleDevice()
{
    if(ON==0x00)
    {
        switch(COLOUR)
        {
            case 0x00:
            GREEN_Write(1u);
            RED_Write(0u);
            BLUE_Write(0u);
            break;
            case 0x01:
            GREEN_Write(0u);
            RED_Write(1u);
            BLUE_Write(0u);
            break;
            case 0x02:
            GREEN_Write(0u);
            RED_Write(0u);
            BLUE_Write(1u);
            break;
        }
    }
}
            

void CustomEventHandler(uint32 event, void * eventParam)
{           
        
        /* Structure to store data written by Client */
        
       
        switch(event)
         {
        case CYBLE_EVT_STACK_ON:
            CyBle_GappStartAdvertisement(CYBLE_ADVERTISING_FAST);
        /* This event is generated when BLE stack is ON */
            break;
     
        case CYBLE_EVT_GAP_DEVICE_DISCONNECTED:
        
            CyBle_GappStartAdvertisement(CYBLE_ADVERTISING_FAST);
            break;

        case CYBLE_EVT_GATT_CONNECT_IND:
            connectionHandle = *(CYBLE_CONN_HANDLE_T *) eventParam;
            break;
            
        case CYBLE_EVT_GATTS_WRITE_REQ:
                       
            /* Extract the Write data sent by Client */
             wrReqParam = (CYBLE_GATTS_WRITE_REQ_PARAM_T *) eventParam;
            /* If the attribute handle of the characteristic written to
            * is equal to that of RGB_LED characteristic, then extract
            * the RGB LED data */
             if(CYBLE_LED_LED_CONTROL_CHAR_HANDLE ==wrReqParam->handleValPair.attrHandle)
             {
            /* Store RGB LED data in local array */
             ON = (uint8) wrReqParam->handleValPair.value.val[0];
             COLOUR =(uint8) wrReqParam->handleValPair.value.val[1];
           
                
            HandleDevice();
            CyBle_GattsWriteRsp(connectionHandle);
             }
            /* Send the response to the write request received. */
            
            
                    /* This event is generated when the connected Central */
                    /* device sends a Write request. */
                    /* The parameter ‘eventParam’ contains the data written */
        break;

         default:
         break;
 }
}


int main(void)
{
    CyGlobalIntEnable; /* Enable global interrupts. */
   // CyBle_Init();
    CyBle_Start(CustomEventHandler);
    /* Place your initialization/startup code here (e.g. MyInst_Start()) */

    for(;;)
    {
        CyBle_ProcessEvents();
    
        
    }
}

/* [] END OF FILE */
